/* Copyright 2017, Additive Regularization of Topic Models.

   Author: Marina Suvorova (m.dudarenko@gmail.com)
   
   This class proceeds scoring of sparsity of Theta matrix.
   
   Parameters:
   - topic_name (array with topic names to score)
   - eps

*/

#pragma once

#include <string>
#include <vector>

#include "artm/score_calculator_interface.h"

namespace artm {
namespace score {

class SparsityTheta : public ScoreCalculatorInterface {
 public:
  explicit SparsityTheta(const ScoreConfig& config) : ScoreCalculatorInterface(config) {
    config_ = ParseConfig<SparsityThetaScoreConfig>();
  }

  virtual bool is_cumulative() const { return true; }

  virtual std::shared_ptr<Score> CreateScore();

  virtual void AppendScore(const Score& score, Score* target);

  virtual void AppendScore(
      const Item& item,
      const std::vector<artm::core::Token>& token_dict,
      const artm::core::PhiMatrix& p_wt,
      const artm::ProcessBatchesArgs& args,
      const std::vector<float>& theta,
      Score* score);

  virtual ScoreType score_type() const { return ::artm::ScoreType_SparsityTheta; }

 private:
  SparsityThetaScoreConfig config_;
};

}  // namespace score
}  // namespace artm
